Subject: Re: [GSoC][RFC PATCH 0/2] Add refs list subcommand

From: Junio C Hamano <[email-masked]>
Date: Sat, 14 Jun 2025 16:45:31 -0700

Meet Soni <[email-masked]> writes:

> This RFC is meant to start a broader discussion on:
>
>   - The desired default behavior of pattern matching in git refs list
>
>   - Which features from both git-show-ref and git-for-each-ref should be
>     preserved, rethought, or dropped
>
>   - How much backward compatibility we want to offer, and through what
>     interface (e.g., compatibility flags)
>
> Feedback and thoughts on these topics would be very welcome.

In addition to these three points, 0th point perhaps is "Is it
desirable to unify these two commands in the first place?"

I only use "show-ref" when I care about a single ref in a script,
expecting to be able to switch on its exit status.  Everything else
I'd use for-each-ref.

But then that particular unique advantage of show-ref over for-each-ref
can be done with "rev-parse --verify".

So, I'd rather not to see yet another command to do the same thing.
Rather, is it insufficient to just use for-each-ref or rev-parse,
let the sleeping show-ref alone, and be happy?

> Meet Soni (2):
>   builtin/refs: add list subcommand
>   t: add tests for refs list subcommand
>
>  Documentation/git-refs.adoc |  25 ++++++++
>  builtin/refs.c              | 110 ++++++++++++++++++++++++++++++++++++
>  t/meson.build               |   1 +
>  t/t1461-refs-list.sh        |  95 +++++++++++++++++++++++++++++++
>  4 files changed, 231 insertions(+)
>  create mode 100755 t/t1461-refs-list.sh